package com.alcorlink.smartcard;


import amlib.ccid.Reader;
import amlib.ccid.ReaderAT45D041;
import amlib.ccid.ReaderException;
import amlib.ccid.SCError;
import amlib.hw.HardwareInterface;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class AT45D041_Activity  extends ReaderActivity {

	private String mStrMessage;
	private ReaderAT45D041 m45D;

	private Button mBtOpen;
	private Button mBtClose;
	private Button mBtPower;
	private Button mBtMainMemRead;
	private Button mBtBuff1Read;
	private Button mBtBuff2Read;
	private Button mBtMainMemPagetoBuf1Xfr;
	private Button mBtMainMemPagetoBuf2Xfr;
	private Button mBtMainMemPagetoBuf1Comp;
	private Button mBtMainMemPagetoBuf2Comp;
	private Button mBtBuff1Write;
	private Button mBtBuff2Write;
	private Button mBtB1toMwithErase;
	private Button mBtB2toMwithErase;
	private Button mBtB1toMwithoutErase;
	private Button mBtB2toMwithoutErase;
	private Button mBtMemProgThrB1;
	private Button mBtMemProgThrB2;
	private Button mBtAutoReWriteThrB1;
	private Button mBtAutoReWriteThrB2;
	private Button mBtGetStatusReg;

	//private TextView mTextView

	private EditText mEdtPageNum;
	private EditText mEdtAddress;
	private EditText mEdtLength;
	private EditText mEdtDataWrite;


	private static final String TAG = MainActivity.TAG;

	private final static byte Op_MainMRead = (byte)0x52;
	private final static byte Op_MainPage2Buff1 = (byte)0x53 ;
	private final static byte Op_Buff1Read = (byte)0x54 ;
	private final static byte Op_MainPage2Buff2 = (byte)0x55 ;
	private final static byte Op_Buff2Read = (byte)0x56 ;
	private final static byte Op_StatusRegRead = (byte)0x57 ;
	private final static byte Op_AutoPageReWriteBuff1 = (byte)0x58 ;
	private final static byte Op_AutoPageReWriteBuff2 = (byte)0x59 ;
	private final static byte Op_MainMPageBuff1Comp = (byte)0x60 ;
	private final static byte Op_MainMPageBuff2Comp = (byte)0x61 ;
	private final static byte Op_MainMPageProgBuff1 = (byte)0x82 ;
	private final static byte Op_Buff1toMainMPageProgWithErase = (byte)0x83 ;
	private final static byte Op_Buff1Write = (byte)0x84 ;
	private final static byte Op_MainMPageProgBuff2 = (byte)0x85 ;
	private final static byte Op_Buff2toMainMPageProgWithErase = (byte)0x86 ;
	private final static byte Op_Buff2Write = (byte)0x87 ;
	private final static byte Op_Buff1toMainMPageProgWithoutErase = (byte)0x88 ;
	private final static byte Op_Buff2toMainMPageProgWithoutErase = (byte)0x89 ;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		setContentView(R.layout.activity_at45_d041);
		setupViews();
		super.onCreate(savedInstanceState);
	}



	public void OnClickAT45D041Open(View view){
		requestDevPerm();
	}

	public void OnClickAT45D041Close(View view){
		new CloseTask(AT45D041_Activity.this).execute();
	}

	public void OnClickAT45D041Power(View view){
		mPowerDialog.show();
	}

	public void OnClickAT45D041MainMemRead(View view){
		commondCmd("MainMemRead", Op_MainMRead);
	}

	public void OnClickAT45D041Buff1Read(View view){
		commondCmd("Buff1 Read", Op_Buff1Read);
	}

	public void OnClickAT45D041Buff2Read(View view){
		commondCmd("Buff2 Read", Op_Buff2Read);
	}

	public void OnClickAT45D041MainMemPagetoBuf1Xfr(View view){
		commondCmd("MainMemPage to Buf1 Xfr ", Op_MainPage2Buff1);
	}

	public void OnClickAT45D041MainMemPagetoBuf2Xfr (View view){
		commondCmd("MainMemPage to Buf2 Xfr", Op_MainPage2Buff2);
	}

	public void OnClickAT45D041MainMemPagetoBuf1Comp(View view){
		commondCmd("MainMemPage to Buf1 Compare", Op_MainMPageBuff1Comp);
	}

	public void OnClickAT45D041MainMemPagetoBuf2Comp(View view){
		commondCmd("MainMemPage to Buf2 Compare", Op_MainMPageBuff2Comp);
	}

	public void OnClickAT45D041Buff1Write(View view){
		commondCmd("Buff1Write", Op_Buff1Write);
	}

	public void OnClickAT45D041Buff2Write(View view){
		commondCmd("Buff2 Write", Op_Buff2Write);
	}

	public void OnClickAT45D041B1toMwithErase(View view){
		commondCmd("Buffer1to MainMemmory with Erase", Op_Buff1toMainMPageProgWithErase);
	}

	public void OnClickAT45D041B2toMwithErase(View view){
		commondCmd("Buffer2 to MainMemmory with Erase", Op_Buff2toMainMPageProgWithErase);
	}

	public void OnClickAT45D041B1toMwithoutErase(View view){
		commondCmd("Buffer1 to MainMemmory without Erase", Op_Buff1toMainMPageProgWithoutErase);
	}

	public void OnClickAT45D041B2toMwithoutErase(View view){
		commondCmd("Buffer2 to MainMemmory without Erase" ,Op_Buff2toMainMPageProgWithoutErase);
	}

	public void OnClickAT45D041MemProgThrB1(View view){
		commondCmd("Mem Program Through Buffer1", Op_MainMPageProgBuff1);
	}

	public void OnClickAT45D041MemProgThrB2(View view){
		commondCmd("Mem Program Through Buffer2", Op_MainMPageProgBuff2);
	}

	public void OnClickAT45D041AutoReWriteThrB1(View view){
		commondCmd("AutoReWrite Through Buffer1", Op_AutoPageReWriteBuff1);
	}
	public void OnClickAT45D041AutoReWriteThrB2(View view){
		commondCmd("AutoReWrite Through Buffer2", Op_AutoPageReWriteBuff2);
	}
	public void OnClickAT45D041GetStatusReg(View view){
		byte []pWriteData = new byte [1];
		int []pIntReadLen = new int [1];
		byte []pReadData = new byte[1];
		int []pIntReturnLen = new int [1];
		int result;
		pIntReadLen[0] = 1;
		result = m45D.AT45D041Cmd(
				Op_StatusRegRead, 
				0, 
				0, 
				0, 
				pWriteData, 
				pIntReadLen[0], 
				pReadData, 
				pIntReturnLen);
		if (result == 0)
			showBufResult(pIntReturnLen[0], pReadData);
		else
			showResult("GetStatusReg" ,result);
	}






	private void commondCmd(String cmd, byte opCode) {
		int []pIntPageNo = new int [1];
		int []pIntStartAddr = new int[1];
		int intWriteLen;
		byte []pWriteData = new byte [256];
		int []pIntReadLen = new int [1];
		byte []pReadData = new byte[256];
		int []pIntReturnLen = new int [1];
		int result;
		getEditTextInt(mEdtPageNum, pIntPageNo);
		getEditTextInt(mEdtAddress, pIntStartAddr);

		switch (opCode)
		{
		case Op_MainMRead:
		case Op_Buff1Read:
		case Op_Buff2Read:
			intWriteLen = 0;
			getEditTextInt(mEdtLength, pIntReadLen);
			break;
		case Op_Buff1Write:
		case Op_Buff2Write:
		case Op_MainMPageProgBuff1:
		case Op_MainMPageProgBuff2:
			getEditTextHex(mEdtDataWrite, pWriteData, 256*2, pIntReturnLen);
			intWriteLen = pIntReturnLen[0];
			break;
		default :
			pIntReadLen[0] = 0;
			intWriteLen = 0;
			break;
		}
		result = m45D.AT45D041Cmd(
				opCode, 
				pIntPageNo[0], 
				pIntStartAddr[0], 
				intWriteLen, 
				pWriteData, 
				pIntReadLen[0], 
				pReadData, 
				pIntReturnLen);

		switch (opCode)
		{
		case Op_MainMRead:
		case Op_Buff1Read:
		case Op_Buff2Read:
			Log.d(TAG,"result, pIntReturnLen="+pIntReturnLen[0]);
			//shows data
			showBufResult(pIntReturnLen[0], pReadData);
			return;
		}
		showResult(cmd, result);
	}

	/*
	 * length: number of max digits in this field
	 * */ 
	private int getEditTextHex(EditText edt, byte []pBuf, int length, int []pReturnLen)
	{
		byte []pByteArrary;
		String strText; 
		int len;
		strText = edt.getText().toString();
		len = strText.length() ;
		Log.d(TAG, "get length="+len);
		if (len > length || len == 0 || (len%2 !=0))
		{
			mStrMessage = "Wrong length in text Fields ";
			Log.e(TAG, mStrMessage);
			mTextViewResult.setText(mStrMessage);
			return -1;
		}
		pByteArrary = MainActivity.toByteArray(strText);
		Log.d(TAG, "pByteArrary length="+pByteArrary.length);
		System.arraycopy(pByteArrary, 0, pBuf, 0, pByteArrary.length);
		pReturnLen[0] = pByteArrary.length;
		Log.d(TAG, "pBuf[0]=0x"+Integer.toHexString(pBuf[0]));
		return 0;
	}



	private int getEditTextInt(EditText edt, int []pData) {
		byte []pBuf = new byte[4];
		int []pIntReturnLen = new int[1];

		int result;
		result = getEditTextHex(edt, pBuf, 6, pIntReturnLen);//MAX 3 bytes
		if (result != 0)
		{
			return -1;
		}

		for (int i=(pIntReturnLen[0]-1);i>=0;i--)
		{
			pData[0] |= pBuf[i]<< (8*(pIntReturnLen[0]-1-i));
		}
		return 0;
	}



	@Override
	public Reader readerSpecificInit() throws ReaderException{
		int status;
		Log.d(TAG,"readerSpecificInit");

		m45D = new ReaderAT45D041((HardwareInterface) mMyDev);
		status = m45D.open();
		if (status != SCError.READER_SUCCESSFUL) {
			String s = "open AT45D fail:" + SCError.errorCode2String(status);
			Log.e(TAG, s);
			throw new ReaderException(s);
		}
		return m45D;

	}


	@Override
	public void onCreateButtonSetup( ){
		if (mUsbDev != null)
			mBtOpen.setEnabled(true);
		else
			mBtOpen.setEnabled(false);
		mBtClose.setEnabled(false);
		mBtPower.setEnabled(false);
		mBtMainMemRead.setEnabled(false);
		mBtBuff1Read.setEnabled(false);
		mBtBuff2Read.setEnabled(false);
		mBtMainMemPagetoBuf1Xfr.setEnabled(false);
		mBtMainMemPagetoBuf2Xfr.setEnabled(false);
		mBtMainMemPagetoBuf1Comp.setEnabled(false);
		mBtMainMemPagetoBuf2Comp.setEnabled(false);
		mBtBuff1Write.setEnabled(false);
		mBtBuff2Write.setEnabled(false);
		mBtB1toMwithErase.setEnabled(false);
		mBtB2toMwithErase.setEnabled(false);
		mBtB1toMwithoutErase.setEnabled(false);
		mBtB2toMwithoutErase.setEnabled(false);
		mBtMemProgThrB1.setEnabled(false);
		mBtMemProgThrB2.setEnabled(false);
		mBtAutoReWriteThrB1.setEnabled(false);
		mBtAutoReWriteThrB2.setEnabled(false);
		mBtGetStatusReg.setEnabled(false);
	}


	@Override
	public void onOpenButtonSetup(){
		mBtOpen.setEnabled(false);
		mBtClose.setEnabled(true);
		mBtPower.setEnabled(true);
		mBtMainMemRead.setEnabled(true);
		mBtBuff1Read.setEnabled(true);
		mBtBuff2Read.setEnabled(true);
		mBtMainMemPagetoBuf1Xfr.setEnabled(true);
		mBtMainMemPagetoBuf2Xfr.setEnabled(true);
		mBtMainMemPagetoBuf1Comp.setEnabled(true);
		mBtMainMemPagetoBuf2Comp.setEnabled(true);
		mBtBuff1Write.setEnabled(true);
		mBtBuff2Write.setEnabled(true);
		mBtB1toMwithErase.setEnabled(true);
		mBtB2toMwithErase.setEnabled(true);
		mBtB1toMwithoutErase.setEnabled(true);
		mBtB2toMwithoutErase.setEnabled(true);
		mBtMemProgThrB1.setEnabled(true);
		mBtMemProgThrB2.setEnabled(true);
		mBtAutoReWriteThrB1.setEnabled(true);
		mBtAutoReWriteThrB2.setEnabled(true);
		mBtGetStatusReg.setEnabled(true);
	}






	@Override
	public void setButtonView()
	{
		mBtOpen = (Button)findViewById(R.id.AT45D041buttonOpen);
		mBtClose = (Button)findViewById(R.id.AT45D041buttonClose);
		mBtPower = (Button)findViewById(R.id.AT45D041buttonPower);
		mBtMainMemRead = (Button)findViewById(R.id.AT45D041buttonMainMemRead);
		mBtBuff1Read = (Button)findViewById(R.id.AT45D041buttonBuff1Read);
		mBtBuff2Read = (Button)findViewById(R.id.AT45D041buttonBuff2Read);
		mBtMainMemPagetoBuf1Xfr = (Button)findViewById(R.id.AT45D041buttonMainMemPagetoBuf1Xfr);
		mBtMainMemPagetoBuf2Xfr = (Button)findViewById(R.id.AT45D041buttonMainMemPagetoBuf2Xfr);
		mBtMainMemPagetoBuf1Comp = (Button)findViewById(R.id.AT45D041buttonMainMemPagetoBuf1Comp);
		mBtMainMemPagetoBuf2Comp = (Button)findViewById(R.id.AT45D041buttonMainMemPagetoBuf2Comp);
		mBtBuff1Write = (Button)findViewById(R.id.AT45D041buttonBuff1Write);
		mBtBuff2Write = (Button)findViewById(R.id.AT45D041buttonBuff2Write);
		mBtB1toMwithErase = (Button)findViewById(R.id.AT45D041buttonB1toMwithErase);
		mBtB2toMwithErase = (Button)findViewById(R.id.AT45D041buttonB2toMwithErase);
		mBtB1toMwithoutErase = (Button)findViewById(R.id.AT45D041buttonB1toMwithoutErase);
		mBtB2toMwithoutErase = (Button)findViewById(R.id.AT45D041buttonB2toMwithoutErase);
		mBtMemProgThrB1 = (Button)findViewById(R.id.AT45D041buttonMemProgThrB1);
		mBtMemProgThrB2 = (Button)findViewById(R.id.AT45D041buttonMemProgThrB2);
		mBtAutoReWriteThrB1 = (Button)findViewById(R.id.AT45D041buttonAutoReWriteThrB1);
		mBtAutoReWriteThrB2 = (Button)findViewById(R.id.AT45D041buttonAutoReWriteThrB2);
		mBtGetStatusReg = (Button)findViewById(R.id.AT45D041buttonGetStatusReg);
	}

	@Override
	public  void setEditView()
	{
		mEdtPageNum = (EditText)findViewById(R.id.AT45D041EdtPageNum);
		mEdtAddress = (EditText)findViewById(R.id.AT45D041EdtAddressInBuf);
		mEdtLength = (EditText)findViewById(R.id.AT45D041EdtLength);
		mEdtDataWrite = (EditText)findViewById(R.id.AT45D041EdtData);
	}


	@Override
	public  void setTextView()
	{
		mTextViewResult = (TextView)findViewById(R.id.AT45D041TextResult);
	}




}


