package com.alcorlink.smartcard;


import amlib.ccid.Reader;
import amlib.ccid.ReaderAT88SC102;
import amlib.ccid.ReaderException;
import amlib.ccid.SCError;
import amlib.hw.HWType;
import amlib.hw.HardwareInterface;
import amlib.hw.HardwareInterfaceUsb;
import amlib.hw.ReaderHwException;


import android.app.AlertDialog;
import android.app.PendingIntent;
import android.app.ProgressDialog;
import android.app.AlertDialog.Builder;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbManager;
import android.os.AsyncTask;
import android.os.Bundle;
import androidx.appcompat.app.AppCompatActivity;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import java.lang.ref.WeakReference;

public class AT88SC102_Activity extends ReaderActivity {
	private String mStrMessage;
	private ReaderAT88SC102 m88SC102;

	private Button mBtOpen;
	private Button mBtClose;
	private Button mBtPower;
	private Button mBtSetFPinH;
	private Button mBtSetFPinL;
	private Button mBtSetRPinH;
	private Button mBtSetRPinL;
	private Button mBtReset;
	private Button mBtBitsRead;
	private Button mBtBitsIncAddr;
	private Button mBtBitsGotoAddr;
	private Button mBtBitsGetCurAddr; 
	private Button mBtSingleBitWrite; 
	private Button mBtSingleBitErase;
	private Button mBtByteIncAddr;
	private Button mBtBytesRead;
	private Button mBtBytesWrite;
	private Button mBtBytesCompare;

	private TextView mTextBitsGetCurAddr;

	private EditText mEdtBitsRead;
	private EditText mEdtBitsIncAddr;
	private EditText mEdtBitsGotoAddr;
	private EditText mEdtByteIncAddr;
	private EditText mEdtBytesRead;
	private EditText mEdtBytesWrite;
	private EditText mEdtBytesCompare;



	private static final String TAG = MainActivity.TAG;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		setContentView(R.layout.activity_at88sc102);
		setupViews();
		super.onCreate(savedInstanceState);
	}


	public void OnClickAT88SC102Open (View view){
		requestDevPerm();
	}

	public void OnClickAT88SC102Close (View view){
		new CloseTask(AT88SC102_Activity.this).execute();
	}

	public void OnClickAT88SC102Power(View view){
		mPowerDialog.show();
	}


	public void OnClickAT88SC102SetFusPinH (View view){
		int result;
		result = m88SC102.AT88SC102Cmd_SetFusPinHigh();
		showResult("SetFusPinHigh", result);
	}

	public void OnClickAT88SC102SetFusPinL (View view){
		int result;
		result = m88SC102.AT88SC102Cmd_SetFusPinLow();
		showResult("SetFusPinLow", result);
	}

	public void OnClickAT88SC102SetRstPinH (View view){
		int result;
		result = m88SC102.AT88SC102Cmd_SetRstPinHigh();
		showResult("SetRstPinHigh", result);
	}

	public void OnClickAT88SC102SetRstPinL (View view){
		int result;
		result = m88SC102.AT88SC102Cmd_SetRstPinLow();
		showResult("SetRstPinLow", result);
	}

	public void OnClickAT88SC102Reset (View view){
		int result;
		result = m88SC102.AT88SC102Cmd_OpReset();
		showResult("Reset", result);
	}

	public void OnClickAT88SC102BitsRead (View view){
		int []pLen = new int[1];
		int result;
		byte []pDataBuffer = new byte[256];
		//get addr
		result = getEditTextDec(mEdtBitsRead, pLen, 3);
		if (result != 0)
		{
			return;
		}

		result = m88SC102.AT88SC102Cmd_OpBitsRead(pLen[0], pDataBuffer);
		if (result == 0)
		{
			//shows data
			showBufResult(pLen[0], pDataBuffer);
		}
		else
			showResult("BitsRead", result);
	}

	public void OnClickAT88SC102BitsIncAddr (View view){
		int []pLen = new int[1];
		int result;
		//get addr
		result = getEditTextDec(mEdtBitsIncAddr, pLen, 3);
		if (result != 0)
		{
			return;
		}
		result = m88SC102.AT88SC102Cmd_OpBitsIncAddr(pLen[0]);
		showResult("BitsIncAddr", result);
	}


	public void  OnClickAT88SC102BitsGoAddr(View view){
		int []pAddr = new int[1];
		int result;
		//get addr
		result = getEditTextDec(mEdtBitsGotoAddr, pAddr, 4);
		if (result != 0)
		{
			return;
		}

		result = m88SC102.AT88SC102Cmd_OpBitsGotoAddr(pAddr[0]);
		showResult("BitsGotoAddr", result);
	}

	public void  OnClickAT88SC102BitsGetCurAddr(View view){
		int []pAddr = new int[1];
		int result;
		result = m88SC102.AT88SC102Cmd_OpBitGetAddr(pAddr);
		showResult("BitGetAddr", result);
		if (result != 0)
		{
			return;
		}
		mTextBitsGetCurAddr.setText("Current Address(Dec):"+ Integer.toString(pAddr[0]&0x0000ffff));

	}

	public void OnClickAT88SC102SingleBitWrite (View view){
		int result;
		result = m88SC102.AT88SC102Cmd_OpSingleBitWrite();
		showResult("SingleBitWrite", result);
	}

	public void  OnClickAT88SC102SingleBitErase(View view){
		int result;
		result = m88SC102.AT88SC102Cmd_OpSingleBitErase();
		showResult("SingleBitErase", result);
	}

	public void OnClickAT88SC102ByteIncAddr (View view){
		int []pAddr = new int[1];
		int result;
		//byte []pDataBuffer = new byte[256];
		//get addr
		result = getEditTextDec(mEdtByteIncAddr, pAddr, 3);
		if (result != 0)
		{
			return;
		}

		result = m88SC102.AT88SC102Cmd_OpBytesIncAddr(pAddr[0]);
		showResult("ByteIncAddr", result);
	}

	public void OnClickAT88SC102ByteRead (View view){
		int []pLen = new int[1];
		byte []pDataBuffer = new byte[256];
		int result;
		//byte []pDataBuffer = new byte[256];
		//get addr
		result = getEditTextDec(mEdtBytesRead, pLen, 3);
		if (result != 0)
		{
			return;
		}

		result = m88SC102.AT88SC102Cmd_OpBytesRead(pLen[0], pDataBuffer);
		if (result == 0)
		{
			//shows data
			showBufResult(pLen[0], pDataBuffer);
		}
		else
			showResult("ByteRead", result);
	}

	public void  OnClickAT88SC102ByteWrite(View view){
		byte []pDataBuffer = new byte[256];
		byte []pReturnLength = new byte [1];
		int result;
		//byte []pDataBuffer = new byte[256];
		//get addr
		result = getEditTextHex(mEdtBytesWrite, pDataBuffer, 96, pReturnLength);
		if (result != 0)
		{
			return;
		}
		result = m88SC102.AT88SC102Cmd_OpBytesWrite(pReturnLength[0], pDataBuffer);

		showResult("ByteWrite", result);
	}

	public void OnClickAT88SC102ByteCompare (View view){
		byte []pDataBuffer = new byte[256];
		byte []pReturnLength = new byte [1];
		int result;
		//byte []pDataBuffer = new byte[256];
		//get addr
		result = getEditTextHex(mEdtBytesCompare, pDataBuffer, 96, pReturnLength);
		if (result != 0)
		{
			return;
		}

		result = m88SC102.AT88SC102Cmd_OpBytesComp(pReturnLength[0], pDataBuffer);

		showResult("ByteCompare", result);
	}

	//=============================================================================

	/*
	 * length: number of max digits in this field 
	 */
	private int getEditTextDec(EditText edt, int []pBuf, int length) {

		String strText; 
		int len;
		strText = edt.getText().toString();
		len = strText.length() ;
		if (len > length || len == 0)
		{
			mStrMessage = "Wrong length in text Fields ";
			Log.e(TAG, mStrMessage);
			mTextViewResult.setText(mStrMessage);
			return -1;
		}

		pBuf[0] =Integer.parseInt(edt.getText().toString());

		return 0;

	}


	private int getEditTextHex(EditText edt, byte []pBuf, int length, byte []pRetLen)
	{
		byte []pByteArrary;
		String strText; 
		int len;
		strText = edt.getText().toString();

		len = strText.length() ;
		Log.d(TAG, "Lenght="+ len);
		if (len > (length*2) || len == 0 || (len%2 != 0))
		{
			mStrMessage = "Wrong length in Data Fields ";
			Log.e(TAG, mStrMessage);
			mTextViewResult.setText(mStrMessage);
			return -1;
		}
		pByteArrary = MainActivity.toByteArray(strText);
		len = pByteArrary.length;

		Log.d(TAG, "Byte array Lenght="+ len);
		for (int i=0; i<(len); i++)
		{
			pBuf[i] = pByteArrary[i];
			Log.d(TAG, "pBuf[" + i +"]=0x"+Integer.toHexString(pBuf[i]));
		}
		//Log.d(TAG, "pBuf[1]=0x"+Integer.toHexString(pBuf[1]));
		pRetLen[0] = (byte)len;
		return 0;
	}


	@Override
	public Reader readerSpecificInit() throws ReaderException{
		int status;
		Log.d(TAG,"readerSpecificInit");

		m88SC102 = new ReaderAT88SC102((HardwareInterface) mMyDev);
		status = m88SC102.open();
		if (status != SCError.READER_SUCCESSFUL) {
			String s = "open AT88SC102 fail:" + SCError.errorCode2String(status);
			Log.e(TAG, s);
			throw new ReaderException(s);
		}
		return m88SC102;
	}





	@Override
	public void onCreateButtonSetup(){
		if (mUsbDev != null)
			mBtOpen.setEnabled(true);
		else
			mBtOpen.setEnabled(false);
		mBtClose.setEnabled(false);
		mBtPower.setEnabled(false);
		mBtSetFPinH.setEnabled(false);
		mBtSetFPinL.setEnabled(false);
		mBtSetRPinH.setEnabled(false);
		mBtSetRPinL.setEnabled(false);
		mBtReset.setEnabled(false);
		mBtBitsRead.setEnabled(false);
		mBtBitsIncAddr.setEnabled(false);
		mBtBitsGotoAddr.setEnabled(false);
		mBtBitsGetCurAddr.setEnabled(false);
		mBtSingleBitWrite.setEnabled(false);
		mBtSingleBitErase.setEnabled(false);
		mBtByteIncAddr.setEnabled(false);
		mBtBytesRead.setEnabled(false);
		mBtBytesWrite.setEnabled(false);
		mBtBytesCompare.setEnabled(false);
	}

	@Override
	public  void onOpenButtonSetup(){
		mBtOpen.setEnabled(false);
		mBtClose.setEnabled(true);
		mBtPower.setEnabled(true);
		mBtSetFPinH.setEnabled(true);
		mBtSetFPinL.setEnabled(true);
		mBtSetRPinH.setEnabled(true);
		mBtSetRPinL.setEnabled(true);
		mBtReset.setEnabled(true);
		mBtBitsRead.setEnabled(true);
		mBtBitsIncAddr.setEnabled(true);
		mBtBitsGotoAddr.setEnabled(true);
		mBtBitsGetCurAddr.setEnabled(true);
		mBtSingleBitWrite.setEnabled(true);
		mBtSingleBitErase.setEnabled(true);
		mBtByteIncAddr.setEnabled(true);
		mBtBytesRead.setEnabled(true);
		mBtBytesWrite.setEnabled(true);
		mBtBytesCompare.setEnabled(true);

	}






	@Override
	public void setButtonView()
	{
		mBtOpen = (Button)findViewById(R.id.AT88SC102buttonOpen);
		mBtClose = (Button)findViewById(R.id.AT88SC102buttonClose);
		mBtPower = (Button)findViewById(R.id.AT88SC102buttonPower);
		mBtSetFPinH = (Button)findViewById(R.id.AT88SC102buttonSetFusPinH);
		mBtSetFPinL = (Button)findViewById(R.id.AT88SC102buttonSetFusPinL);
		mBtSetRPinH = (Button)findViewById(R.id.AT88SC102buttonSetRstPinH);
		mBtSetRPinL = (Button)findViewById(R.id.AT88SC102buttonSetRstPinL);
		mBtReset = (Button)findViewById(R.id.AT88SC102buttonReset);
		mBtBitsRead = (Button)findViewById(R.id.AT88SC102buttonBitsRead);
		mBtBitsIncAddr = (Button)findViewById(R.id.AT88SC102buttonBitsIncAddr);
		mBtBitsGotoAddr = (Button)findViewById(R.id.AT88SC102buttonBitsGoAddr );
		mBtBitsGetCurAddr = (Button)findViewById(R.id.AT88SC102buttonBitsGetCurAddr );
		mBtSingleBitWrite = (Button)findViewById(R.id.AT88SC102buttonSingleBitWrite);
		mBtSingleBitErase = (Button)findViewById(R.id.AT88SC102buttonSingleBitErase);
		mBtByteIncAddr = (Button)findViewById(R.id.AT88SC102buttonByteIncAddr);
		mBtBytesRead = (Button)findViewById(R.id.AT88SC102buttonByteRead);
		mBtBytesWrite = (Button)findViewById(R.id.AT88SC102buttonByteWrite);
		mBtBytesCompare = (Button)findViewById(R.id.AT88SC102buttonByteCompare);

	}

	@Override
	public  void setEditView()
	{
		mEdtBitsRead = (EditText)findViewById(R.id.AT88SC102EditTextBitsRead);
		mEdtBitsIncAddr = (EditText)findViewById(R.id.AT88SC102EditTextBitsIncAddr);
		mEdtBitsGotoAddr = (EditText)findViewById(R.id.AT88SC102EditTextBitsGoAddr);
		mEdtByteIncAddr = (EditText)findViewById(R.id.AT88SC102EditTextByteIncAddr);
		mEdtBytesRead = (EditText)findViewById(R.id.AT88SC102EditTextByteRead);
		mEdtBytesWrite = (EditText)findViewById(R.id.AT88SC102EditTextByteWrite);
		mEdtBytesCompare = (EditText)findViewById(R.id.AT88SC102EditTextByteCompare);
		//mmEdtResult = (EditText)findViewById(R.id.

	}


	@Override
	public  void setTextView()
	{
		mTextBitsGetCurAddr = (TextView)findViewById(R.id.AT88SC102TextBitsGetCurAddr);
		mTextViewResult = (TextView)findViewById(R.id.AT88SC102TextResult);

	}

	private static void setUpWaitDialog(AT88SC102_Activity act,String msg){
		act.mWaitProgress.setMessage(msg);
		act.mWaitProgress.setCancelable(false);
		act.mWaitProgress.setProgressStyle(ProgressDialog.STYLE_SPINNER);
		act.mWaitProgress.show();
	}


}
