package com.alcorlink.smartcard;

import android.hardware.usb.UsbDevice;

public class DeviceCheck {
    static final int VENDOR_ID_058F =  0x058f;
    static final int VENDOR_ID_2CE3 =  0x2CE3;

    static public boolean isAlcorReader(UsbDevice udev){

        if (udev.getVendorId() == VENDOR_ID_058F && checkPid(udev)) {
            return true;
        } else if (udev.getVendorId() == VENDOR_ID_2CE3 && checkPid(udev)){
            return true;
        }

        return false;

    }
    static private Boolean checkPid(UsbDevice udev){
        switch (udev.getProductId()) {
            case 0x9520:
            case 0x9522:
            case 0x9525:
            case 0x9526:

            case 0x9540:

            case 0x9563:
            case 0x9571:

            case 0x9572:
            case 0x9573:

            case 0x9567:
                return true;
            default:
                return false;
        }
    }

    static public String pid2DevName(int pid) {
        String name = null;
        switch (pid)
        {
            case 0x9520:
            case 0x9522:
            case 0x9540:
            case 0x9525:
            case 0x9563:
                name = new String("SAM Card Reader");
                break;
            case 0x9571:
                name = new String("NFC Reader");
                break;
            case 0x9526:
            case 0x9572:
            case 0x9573:
            case 0x9567:
                name = new String("Smart Card Reader/NFC Reader");
                break;
        }
        return name;
    }

    static public Boolean isNFCEnables(int pid) {
        switch (pid) {
            case 0x9571:
            case 0x9572:
            case 0x9573:
            case 0x9526:
            case 0x9567:
             return true;
            default:
                return false;
        }
    }

    static public boolean isTwoInterface(int pid) {
        boolean ret = false;
        switch (pid) {
            case 0x9567:
            case 0x9573:
                ret = true;
                break;
            default:
                ret = false;
                break;
        }
        return ret;
    }
}
