package com.alcorlink.smartcard;




import amlib.ccid.SCError;
import amlib.ccid.Reader;
import amlib.ccid.Reader4428;
import amlib.ccid.ReaderException;
import amlib.hw.HWType;
import amlib.hw.HardwareInterface;
import amlib.hw.HardwareInterfaceUsb;
import amlib.hw.ReaderHwException;

import android.app.AlertDialog;
import android.app.PendingIntent;
import android.app.ProgressDialog;
import android.app.AlertDialog.Builder;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbManager;
import android.os.AsyncTask;
import android.os.Bundle;
import androidx.appcompat.app.AppCompatActivity;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import java.lang.ref.WeakReference;

public class SLE4428_Activity extends ReaderActivity {

	private String mStrMessage;
	private Reader4428 m4428;

	private Button mBtOpen;
	private Button mBtPower;
	private Button mBtWEwithPB;
	private Button mBtWEwithoutPB;
	private Button mBtwritePBDC;
	private Button mBtread9;
	private Button mBtread8;
	private Button mBtWEC;
	private Button mBtVerify1;
	private Button mBtVerify2;
	private Button mBtVPEEC;
	private Button mBtClose;
	

	private EditText mEdtAddrWrite;
	private EditText mEdtDataWrite;
	private EditText mEdtAddrRead;
	private EditText mEdtLenRead;
	private EditText mEdtDataWriteErr;
	private EditText mEdtDataVerify1;
	private EditText mEdtDataVerify2;

	private static final String TAG = MainActivity.TAG;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		setContentView(R.layout.activity_sle4428);
		setupViews();
		super.onCreate(savedInstanceState);
	}



	public void OnClickSLE4428Open(View view){
		Log.d(TAG, "4428OpenOnClick");
		requestDevPerm();
	}
	
	public void OnClickSLE4428Power(View view){
		mPowerDialog.show();
	}

	
	public void  OnClickSLE4428WEwithPB(View view){
		Log.d(TAG, "SLE4428WEwithPBOnClick");
		int result;
		int[]pAddress = new int[1];
		byte []pData = new byte [1];
		getEditTextDec(mEdtAddrWrite, pAddress, 3);
		getEditTextHexByte(mEdtDataWrite, pData);
	
		result = m4428.SLE4428Cmd_WriteEraseWithPB(pAddress[0], pData[0]); 
	
		showResult("WriteEraseWithPB", result);
	}

	public void  OnClickSLE4428WEwithoutPB(View view){
		Log.d(TAG, "SLE4428WEwithoutPBOnClick");
		int result;
		int[]pAddress = new int[1];
		byte []pData = new byte [1];
		getEditTextDec(mEdtAddrWrite, pAddress, 3);
		getEditTextHexByte(mEdtDataWrite, pData);
		result = m4428.SLE4428Cmd_WriteEraseWithoutPB(pAddress[0], pData[0]); 
		showResult("WriteEraseWithoutPB", result);
	}

	public void  OnClickSLE4428WriteProtectDataCompare(View view){
		Log.d(TAG, "SLE4428WPDCOnClick");
		int result;
		int[]pAddress = new int[1];
		byte []pData = new byte [1];
		getEditTextDec(mEdtAddrWrite, pAddress, 3);
		getEditTextHexByte(mEdtDataWrite, pData);
		result = m4428.SLE4428Cmd_WritePBWithDataComparison(pAddress[0], pData[0]); 
		showResult("WritePBWithDataComparison", result);
	}

	public void  OnClickSLE4428Read9(View view){
		Log.d(TAG, "SLE4428Read9OnClick");
		int result;
		int[]pAddress = new int[1];
		byte []pLen = new byte [1];
		byte []pReadData;
		byte []pReadPBData;
		int []pIntReturnLen = new int [1];
		getEditTextDec(mEdtAddrRead, pAddress, 3);
		getEditTextHexByte(mEdtLenRead, pLen);
		pReadData = new byte[pLen[0]];
		pReadPBData = new byte[0x000000ff&pLen[0]];
		result = m4428.SLE4428Cmd_Read9Bits(pAddress[0], pLen[0], pReadData, pReadPBData, pIntReturnLen);
		if (result == SCError.READER_SUCCESSFUL )
		{
			showResultRead9bits(pLen[0],pReadData,pReadPBData);
		}
		else
			showResult("Read9bits", result);
	}

	public void OnClickSLE4428CRead8(View view){
		Log.d(TAG, "SLE4428CRead8OnClick");
		int result;
		int[]pAddress = new int[1];
		byte []pLen = new byte [1];
		byte []pReadData;
		int []pIntReturnLen = new int [1];
		getEditTextDec(mEdtAddrRead, pAddress, 3);
		getEditTextHexByte(mEdtLenRead, pLen);
		pReadData = new byte[pLen[0]];
		result = m4428.SLE4428Cmd_Read8Bits(pAddress[0], pLen[0], pReadData, pIntReturnLen);
		if (result == SCError.READER_SUCCESSFUL )
		{
			showResultRead8bits(pLen[0],pReadData);
		}
		else
			showResult("REad8bits", result);
	}

	public void  OnClickSLE4428WriteErrCount(View view){
		Log.d(TAG, "SLE4428WECOnClick");
		int result;
		byte []pData = new byte [1];
		getEditTextHexByte(mEdtDataWriteErr, pData);
		result = m4428.SLE4428Cmd_WriteErrorCounter(pData[0]);

		showResult("WriteErrorCounter", result);
		
	}

	public void  OnClickSLE4428V1P(View view){
		Log.d(TAG, "SLE4428V1POnClick");
		int result;
		byte []pData = new byte [1];
		getEditTextHexByte(mEdtDataWriteErr, pData);
		result = m4428.SLE4428Cmd_Verify1stPSC(pData[0]);
		showResult("Verify1stPSC", result);
	}

	public void  OnClickSLE4428V2P(View view){
		Log.d(TAG, "SLE4428V2POnClick");
		int result;
		byte []pData = new byte [1];
		getEditTextHexByte(mEdtDataWriteErr, pData);
		result = m4428.SLE4428Cmd_Verify2ndPSC(pData[0]);
		showResult("Verify2ndPSC", result);
	}

	public void  OnClickSLE4428VPEEC(View view){
		Log.d(TAG, "SLE4428VPEECOnClick");
		int result;
		byte []pDataV1 = new byte [1];
		byte []pDataV2 = new byte [1];
		int []pIntErrorReason = new int[1];
		getEditTextHexByte(mEdtDataVerify1, pDataV1);
		getEditTextHexByte(mEdtDataVerify2, pDataV2);
		result = m4428.SLE4428Cmd_VerifyPSCAndEraseErrorCounter(pDataV1[0], pDataV2[0], pIntErrorReason);
		showResult("VerifyPSCAndEraseErrorCounter", result);
	}


	public void OnClickSLE4428Close(View view){
		new CloseTask(SLE4428_Activity.this).execute();
	}


	/*
	 *
	 * @param edt
	 * @param pBuf
	 * @param length number of digits
	 * @param pRetLen  how many bytes
	 * @return
	 */
	private int getData(EditText edt, byte []pBuf, int length, byte []pRetLen)
	{
		byte []pByteArrary;
		String strText; 
		int len;
		strText = edt.getText().toString();
		
		len = strText.length() ;
		Log.d(TAG, "Lenght="+ len);
		if (len > (length*2) || len == 0 || (len%2 != 0))
		{
			mStrMessage = "Wrong length in Data Fields ";
			Log.e(TAG, mStrMessage);
			mTextViewResult.setText(mStrMessage);
			return -1;
		}
		pByteArrary = MainActivity.toByteArray(strText);
		len = pByteArrary.length;
		
		Log.d(TAG, "Byte array Lenght="+ len);
	
		
		for (int i=0; i<(len); i++)
		{
			pBuf[i] = pByteArrary[i];
			Log.d(TAG, "pBuf[" + i +"]=0x"+Integer.toHexString(pBuf[i]));
		}
		 
		
		//Log.d(TAG, "pBuf[1]=0x"+Integer.toHexString(pBuf[1]));
		pRetLen[0] = (byte)len;
		return 0;
	}
	
	/*
	 * length: number of max digits in this field 
	 */
	private int getEditTextDec(EditText edt, int []pBuf, int length) {
		
		String strText; 
		int len;
		strText = edt.getText().toString();
		len = strText.length() ;
		if (len > length || len == 0)
		{
			mStrMessage = "Wrong length in text Fields ";
			Log.e(TAG, mStrMessage);
			mTextViewResult.setText(mStrMessage);
			return -1;
		}

		pBuf[0] =Integer.parseInt(edt.getText().toString());
		
		return 0;
		
	}
	
	/*
	 * length: number of max digits in this field
	 * */ 
	private int getEditTextHexByte(EditText edt, byte []pData)
	{
		byte []pBuf = new byte[2];
		byte []pReturnLen = new byte[1];
		int result;
		result = getData(edt, pBuf, 2, pReturnLen);
		if (result != 0)
			return result;
		if (pReturnLen[0] != 1) //one byte
			return -1;
		pData[0] = pBuf[0];
		Log.d(TAG, "Read Byte =" + Integer.toHexString(pBuf[0]));
		return 0;
	}


	private int getSlotStatus(){
		int ret = SCError.READER_NO_CARD;
		byte []pCardStatus = new byte[1];

		/*detect card hotplug events*/
		ret = m4428.getCardStatus(pCardStatus);
		if (ret == SCError.READER_SUCCESSFUL) {
			if (pCardStatus[0] == Reader.SLOT_STATUS_CARD_ABSENT) {
				ret = SCError.READER_NO_CARD;
			} else if (pCardStatus[0] == Reader.SLOT_STATUS_CARD_INACTIVE) {
				ret = SCError.READER_CARD_INACTIVE;
			} else
				ret = SCError.READER_SUCCESSFUL;
		}

		return ret;
	}

	@Override
	public Reader readerSpecificInit() throws ReaderException{
		int status;
		Log.d(TAG,"readerSpecificInit");
		m4428 = new Reader4428((HardwareInterface) mMyDev);
		status = m4428.open();
		if (status != SCError.READER_SUCCESSFUL) {
			String s = "open SLE4428 fail:" + SCError.errorCode2String(status);
			Log.e(TAG, s);
			throw new ReaderException(s);
		}
		return m4428;
	}




	@Override
	public void setButtonView()
	{
		mBtOpen = (Button)findViewById(R.id.SLE4428buttonOpen);
		mBtPower = (Button)findViewById(R.id.SLE4428buttonPower);
		mBtWEwithPB = (Button)findViewById(R.id.SLE4428WEwithPB);
		mBtWEwithoutPB = (Button)findViewById(R.id.SLE4428WEwithoutPB);
		mBtwritePBDC = (Button)findViewById(R.id.SLE4428WritePBwithDataComp);
		mBtread9= (Button)findViewById(R.id.SLE4428ReadP9Bits);
		mBtread8 = (Button)findViewById(R.id.SLE4428ReadP8Bits);
		mBtWEC = (Button)findViewById(R.id.SLE4428WriteErrorCounter);
		mBtVerify1 = (Button)findViewById(R.id.SLE4428Verify1stPSC);
		mBtVerify2 = (Button)findViewById(R.id.SLE4428Verify2stPSC);
		mBtVPEEC = (Button)findViewById(R.id.SLE4428VerifyPSCandEraseErrorCount);
		mBtClose = (Button)findViewById(R.id.SLE4428buttonClose);
	}

	@Override
	public void setEditView()
	{
		mEdtAddrWrite = (EditText)findViewById(R.id.SLE4428EditTextAddrWrite);
		mEdtDataWrite = (EditText)findViewById(R.id.SLE4428EditTextDataWrite);
		mEdtAddrRead = (EditText)findViewById(R.id.SLE4428EditTextAddrRead);
		mEdtLenRead = (EditText)findViewById(R.id.SLE4428EditTextLenRead);
		mEdtDataWriteErr = (EditText)findViewById(R.id.SLE4428EditTextDataVeriy);
		mEdtDataVerify1 = (EditText)findViewById(R.id.SLE4428EditTextDataPSC1);
		mEdtDataVerify2 = (EditText)findViewById(R.id.SLE4428EditTextDataPSC2);
	}


	@Override
	public void setTextView()
	{
		mTextViewResult = (TextView)findViewById(R.id.SLE4428TextResult);
	}



	private void showResultRead9bits(byte len, byte []pData, byte[]pPBData)
	{
		int i;

		showResultRead8bits(len, pData);
		StringBuilder msg = new StringBuilder();
		mTextViewResult.getText().toString();
		msg.append(mTextViewResult.getText().toString()).append("\nReadPBData:");
		for (i=0;i< len;i++)
		{
			msg.append(" ").append(Integer.toHexString(0x000000ff & pPBData[i]));
		}
		mTextViewResult.setText(msg.toString());
	}

	private void showResultRead8bits(byte len, byte []pData)
	{
		int i;
		StringBuilder msg = new StringBuilder();
		msg.append("ReadData:");
		for (i=0;i< len;i++)
		{
			msg.append(" ").append(Integer.toHexString(0x000000ff & pData[i]));
		}
		mTextViewResult.setText(msg.toString());
	}



	@Override
	public void onCreateButtonSetup(){
		if (mUsbDev != null)
			mBtOpen.setEnabled(true);
		else
			mBtOpen.setEnabled(false);
		mBtPower.setEnabled(false);
		mBtWEwithPB.setEnabled(false);
		mBtWEwithoutPB.setEnabled(false);
		mBtwritePBDC.setEnabled(false);
		mBtread9.setEnabled(false);
		mBtread8.setEnabled(false);
		mBtWEC.setEnabled(false);
		mBtVerify1.setEnabled(false);
		mBtVerify2.setEnabled(false);
		mBtVPEEC.setEnabled(false);
		mBtClose.setEnabled(false);
	}

	@Override
	public void onOpenButtonSetup(){
		mBtOpen.setEnabled(false);
		mBtPower.setEnabled(true);
		mBtWEwithPB.setEnabled(true);
		mBtWEwithoutPB.setEnabled(true);
		mBtwritePBDC.setEnabled(true);
		mBtread9.setEnabled(true);
		mBtread8.setEnabled(true);
		mBtWEC.setEnabled(true);
		mBtVerify1.setEnabled(true);
		mBtVerify2.setEnabled(true);
		mBtVPEEC.setEnabled(true);
		mBtClose.setEnabled(true);
	}


}
